## wajig 2.7.3

=== debian/changelog ===
wajig (2.7.3) unstable; urgency=low

  * NEWUPGRADES: a bug introduced in 2.5 made this subcommand illegal;
    Closes: #681309
  * STATUSSEARCH: same case as above

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Thu, 12 Jul 2012 12:11:46 +0200

wajig (2.7.2) unstable; urgency=low

  * For some reason, some temp/build files ended up in the source package :(
    Thanks to RM, Adam D. Barratt, for noticing.

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Tue, 03 Jul 2012 21:03:25 +0200

wajig (2.7.1) unstable; urgency=low

  * NEW, NEWDESCRIBE: fix an exception that occurs if package exists only
    for configured foreign architectures; Closes: #679969
  * DESCRIBE: if package does not exist for native architecture, check if it
    does for configured foreign ones before giving up; this is closely
    related to the above-mentioned fix
  * Specify a minimum dpkg version (1.16.2), due to the use of
    --print-foreign-architectures option introduced as a result of the
    above-mentioned fixes

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Mon, 02 Jul 2012 21:04:43 +0200

wajig (2.7) unstable; urgency=low

  * NEW, DETAILNEW, and DESCRIBENEW:
    - make them do as the commands imply; Closes: #670687
    - do not quit if a package is not found in APT cache; Closes: #667068

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Tue, 19 Jun 2012 04:31:23 +0200

wajig (2.6.1) unstable; urgency=low

  * DISTUPGRADE: fix an exception triggered by specifying the --dist option

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Sat, 16 Jun 2012 07:43:15 +0200

wajig (2.6) unstable; urgency=low

  * stop converting COMMANDS to uppercase... be like everyone else
  * polish bash auto-completion, by only auto-completing:
    - names of installed packages where no other name makes sense
    - names of all packages where no other name makes sense
    - names of files/directories where no other name makes sense
    for every other COMMAND, do not auto-complete at all (Reuben Thomas
    helped with this one)

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Wed, 23 May 2012 22:19:10 +0200

wajig (2.5.1) unstable; urgency=low

  * make licence DEP-5 compliant
  * DEPENDENTS: fix an exception that occurs when the sources.list only
    has Wheezy in it.

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Fri, 20 Apr 2012 14:05:30 +0200

wajig (2.5) unstable; urgency=low

  IMPROVEMENTS
  * improve bash completion, thanks again to Reuben Thomas; Closes: #597721
  * avoid displaying a stack trace when quitting an operation (Ctrl+C)
  * the --simulate and --teaching options now display the commands in bold;
    they now also have consistent spacing (single space) between
    non-whitespace characters
  * REMOVEORPHANS, PURGEORPHANS: for the sake of consistency with REMOVE
    and PURGE subcommands, use the --auto-remove option of apt-get;
    Closes: #444150
  * INSTALL, INSTALLSUGGESTED, NEWUPGRADES, AUTODOWNLOAD: use --auto-remove
    option. Seems a more sane way to have that as default, and leads to a
    less-surprising REMOVE/PURGE experience (whereby it would remove packages
    that are not related to packages being removed).
  * INSTALL: when installing using the url method, do keep the downloaded file;
    it will be found in "~/.wajig/$HOSTNAME/"

  BUGS FIXED
  * INSTALLSUGGESTED: don't fail when one of the Suggested dependencies is
    a virtual package, but instead install one the Providers of that
    virtual package.
  * {REMOVE,PURGE}ORPHANS: fix exception that happened with --simulate option
  * AUTODOWNLOAD, TOUPGRADE, NEWDETAIL: fix an exception that occurs when
    ~/.wajig dir is removed
  * fix 'displays incorrect new and upgradeable package count';
    patch by Graeme Hewson; LP #892410
  * fix '"wajig status" gives warning message about stdin not sorted';
    patch by Graeme Hewson; LP #978172

  RESTORED FUNCTIONALITY (Closes: #667856)
  * LISTALL: this was mistakenly removed, so restore it
  * LIST{CACHE,NAMES,PACKAGES,STATUS,INSTALLED}: restore ability to filter on
    a pattern; some people complained about the removal of the feature (in 2.3)
  * TOUPGRADE: sort the list, again
  * restore ability to have multiple-word commands to be separated with dashes,
    e.g. an alias for LISTINSTALLED is LIST-INSTALLED

  MISC
  * remove the (Suggests) dependencies on fping and wget; Python stdlib is
    capable enough
  * README: improve setup instructions, thanking Graeme Hewson (from LP #892410)
  * NEWUPGRADES: doesn't seem to provide much more than TOUGPRADE, so alias it
  * AUTODOWNLOAD, NEW: get rid of --install option; it's overkill
  * PURGEREMOVE: remove --teaching and --simulate options; they display
    incomplete output
  * UNOFFICIAL: simply open the search results page with a web browser instead
    of scanning it and displaying suitable lines for "/etc/apt/sources.list";
    that feature was broken (and nobody complained)

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Wed, 11 Apr 2012 13:52:52 +0200

wajig (2.4.1) unstable; urgency=low

  * 2.4 made an assumption that a user that isn't in 'sudo' group
    is not a sudoer. That's not the case (and it's a bad assumption).

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Tue, 27 Mar 2012 16:07:31 +0200

wajig (2.4) unstable; urgency=low

  * README, TODO, NEWS: if doc path (/usr/share/doc/<package name>) for
    a given package isn't found, check if such a package even exists.
  * INSTALL, INSTALLSUGGESTED: make --recommends and --norecommends options
    conflict.
  * INSTALL: one can now specify a mixture of installables:
    * deb files
    * url files
    * normal packages
    Previously, only one of these types could be installed at a time
  * make bash completer also complete lower-case COMMANDS;
    patch by "Reuben Thomas" <rrt@sc3d.org>
  * Reinstate --simulate and --teaching options:
    - the --simulate option implies that the epilogs of the --help option
      are now redundant so they are now removed. All they did was state what


=== debian/control ===
Source: wajig
Maintainer: Graham Williams <Graham.Williams@togaware.com>
Uploaders: Tshepang Lekhonkhobe <tshepang@gmail.com>
Section: admin
Priority: optional
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.3
Vcs-Browser: http://code.google.com/p/wajig/source/browse
Vcs-Hg: https://wajig.googlecode.com/hg
Homepage: http://wajig.togaware.com

Package: wajig
Architecture: all
Depends: ${misc:Depends},
         python3 (>= 3.2),
         apt,
         python3-apt,
         aptitude,
         dpkg (>= 1.16.2)
Suggests: debconf,
          reportbug,
          apt-move,
          dpkg-repack,
          alien,
          fakeroot,
          apt-file,
          locales,
          deborphan,
          vrms,
          sudo,
          apt-show-versions,
          dctrl-tools,
          debsums,
          netselect-apt,
          dpkg-dev
Description: simple and unified package management for Debian
 Wajig is a single commandline wrapper around apt, apt-cache, dpkg,
 /etc/init.d scripts and more, intended to be easy to use and providing 
 extensive documentation for all of its functions. 
 .
 With a suitable sudo(1) configuration, most (if not all) package installation
 as well as creation tasks can be done from a user shell. Wajig is also 
 suitable for general system administration.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# 2010.10.02 this is modified from a version found at:
# savetheions.com/2010/01/20/packaging-python-applicationsmodules-for-debian/

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp
build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE)
	touch $@
clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	dh_clean
install: build
	dh_testdir
	dh_testroot
	dh_installdirs
	$(MAKE) DESTDIR=$(CURDIR)/debian/wajig install
build-arch:
build-indep:
binary-arch: build install
binary-indep: build install
	dh_fixperms
	dh_installchangelogs
	dh_installdocs
	dh_compress
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb
binary: binary-indep
.PHONY: build clean binary-indep binary install configure

## wajig 2.8

=== Makefile ===
# modified from a version found at:
# savetheions.com/2010/01/20/packaging-python-applicationsmodules-for-debian/

LIBDIR = $(DESTDIR)/usr/share/wajig
BINDIR = $(DESTDIR)/usr/bin
MANDIR = $(DESTDIR)/usr/share/man/man1
CMPDIR = $(DESTDIR)/etc/bash_completion.d

clean:
	rm -rf src/__pycache__

install:
	mkdir -p  $(LIBDIR) $(HLPDIR) $(MANDIR)
	cp src/commands.py  $(LIBDIR)/
	cp src/debfile.py  $(LIBDIR)/
	cp src/debfile-deps.py  $(LIBDIR)/
	cp src/perform.py  $(LIBDIR)/
	cp src/shell.py  $(LIBDIR)/
	cp src/util.py  $(LIBDIR)/
	cp src/wajig.py  $(LIBDIR)/
	cp TUTORIAL $(LIBDIR)/
	cp wajig.1  $(MANDIR)/
	cp wajig.sh $(BINDIR)/wajig
	cp bash-completion $(CMPDIR)/wajig

uninstall:
	rm -rf $(LIBDIR)
	rm -f $(MANDIR)/wajig.1
	rm -f $(BINDIR)/wajig
	rm -f $(CMPDIR)/wajig

=== debian/changelog ===
wajig (2.8) unstable; urgency=low

  * UPDATE: fix performance issue (patch by Robert Luberda); Closes: #705241

  * improve package description:
    - simpler
    - less boastful
    - add a pointer to a guide
    - tis 'wajig', not 'Wajig'

  * SEARCH:
    - make -v|--verbose match short package descriptions in addition to
      package names
    - add -vv, which also searches long package descriptions and displays them;
      the former was available as -v, and the latter is new;
      this functionality was suggested by Reuben Thomas
    - add debtags search; this happens if the string '::' is in the search term

  * SEARCH, INSTALL: fix weird bugs where package '0ad' could not be searched
    for or installed; LP #1182264

  * update TUTORIAL to reflect that allowing any case for commands has
    since been removed; LP #1033536

  * PURGEORPHANS, REMOVEORPHANS:
    - remove --teach option
      + it would need to be too complex in order to be accurate since it
        runs 2 commands, the second one using output of the first
      + this also gets rid of an ugly (and broken) workaround

  * PURGEORPHANS: remove --noauth option; it doesn't make sense here

  * REMOVEORPHANS: add --yes option, for consistency with PURGEORPHANS

  * replace internal function with a more thorough stdlib shutil.which()
    for checking if a particular executable exists;
    this bumps minimum Python dependency to 3.3
  * LISTLOG: add APTLOG as synonym, in place of an erroneously-added SYSLOG

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Tue, 28 May 2013 08:35:08 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
 Package: wajig
 Architecture: all
 Depends: ${misc:Depends},
-         python3 (>= 3.2),
+         python3.3,
          apt,
          python3-apt,
          aptitude,
@@ -32,13 +32,12 @@
           dctrl-tools,
           debsums,
           netselect-apt,
-          dpkg-dev
-Description: simple and unified package management for Debian
- Wajig is a single commandline wrapper around apt, apt-cache, dpkg,
- /etc/init.d scripts and more, intended to be easy to use and providing 
- extensive documentation for all of its functions. 
+          dpkg-dev,
+          debtags
+Description: unified package management front-end for Debian
+ A command-line wrapper around apt, apt-cache, dpkg, aptitude, and more.
+ It's goal is to ease package management by unifying the main functions
+ of these tools from one interface.
  .
- With a suitable sudo(1) configuration, most (if not all) package installation
- as well as creation tasks can be done from a user shell. Wajig is also 
- suitable for general system administration.
-
+ For a short guide, run this command:
+ $ wajig help

## wajig 2.13

=== Makefile ===
# modified from a version found at:
# savetheions.com/2010/01/20/packaging-python-applicationsmodules-for-debian/

LIBDIR = $(DESTDIR)/usr/share/wajig
BINDIR = $(DESTDIR)/usr/bin
MANDIR = $(DESTDIR)/usr/share/man/man1
CMPDIR = $(DESTDIR)/etc/bash_completion.d

clean:
	rm -rf src/__pycache__

install:
	install -d  $(LIBDIR) $(MANDIR) $(CMPDIR)
	cp src/*.py  $(LIBDIR)/
	cp wajig.1  $(MANDIR)/
	install -D wajig.sh $(BINDIR)/wajig
	cp bash-completion $(CMPDIR)/wajig

uninstall:
	rm -rf $(LIBDIR)
	rm -f $(MANDIR)/wajig.1
	rm -f $(BINDIR)/wajig
	rm -f $(CMPDIR)/wajig

=== debian/changelog ===
wajig (2.13) unstable; urgency=medium

  * Remove unit tests... only had 5 tests, and the code isn't really ready
    for it without 'too' much effort; Closes: #735821

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Sun, 19 Jan 2014 15:59:53 +0200

wajig (2.12) unstable; urgency=low

  * bump Standards-Version to 3.9.5: no changes needed
  * README: also read /usr/share/doc/<package name>/README.rst files
  * modernise packaging... use dh-python; work done by Sergey Romanov
  * LIST-SCRIPTS: fix Py3k conversion error; no one saw/reported this
    since it was introduced in version 2.2, until Sergey Romanov, who
    also submitted a fix

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Sat, 14 Dec 2013 19:11:33 +0200

wajig (2.11) unstable; urgency=low

  * UPGRADE: Use the new --with-new-pkgs option of 'apt-get upgrade'
  * EDITSOURCES: Select $VISUAL or $EDITOR (in that order of preference)
    if defined, else use 'sensible-editor'; Closes: #729585

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Mon, 02 Dec 2013 22:23:31 +0200

wajig (2.10) unstable; urgency=low

  * LIST-COMMANDS: accept an optional argument to filter the output;
    this is equivalent to 'wajig list-commands | grep <pattern>'

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Sun, 13 Oct 2013 08:21:30 +0200

wajig (2.9) unstable; urgency=low

  * bump Standards-Version to 3.9.4: no changes needed
  * minimum version for python-apt is now 0.8.9+, due to python3.3 support
  * restore dashes in subcommands in bash completion; suggestion and
    initial patch by Reuben Thomas
  * LIST-LOG: restore wajig log; Karl Schmidt insisted very strongly
  * LIST-COMMANDS: make it one-line per command as it was before;
    Karl insisted strongly on this one too

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Sun, 11 Aug 2013 00:10:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,19 @@
 Uploaders: Tshepang Lekhonkhobe <tshepang@gmail.com>
 Section: admin
 Priority: optional
-Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.3
-Vcs-Browser: http://code.google.com/p/wajig/source/browse
-Vcs-Hg: https://wajig.googlecode.com/hg
+Build-Depends: debhelper (>= 9), dh-python, python3, python3-apt
+X-Python3-Version: >= 3.3
+Standards-Version: 3.9.5
+Vcs-Browser: https://bitbucket.org/tshepang/wajig/src
+Vcs-Hg: https://bitbucket.org/tshepang/wajig
 Homepage: http://wajig.togaware.com
 
 Package: wajig
 Architecture: all
 Depends: ${misc:Depends},
-         python3.3,
+         ${python3:Depends},
          apt,
-         python3-apt,
+         python3-apt (>= 0.8.9),
          aptitude,
          dpkg (>= 1.16.2)
 Suggests: debconf,

## wajig 2.14

=== debian/changelog ===
wajig (2.14) unstable; urgency=low

  * SOURCE: Auto-complete package names (suggested by Reuben Thomas)

  * PURGE-REMOVED: If one removed (not purged) a foreign arch package, and
    then ran 'wajig purge-removed', it would attempt to remove package
    with the same name but on the current architecture; Closes: #691857

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Sun, 11 May 2014 09:47:20 +0200

## wajig 2.17

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,6 @@
 LIBDIR = $(DESTDIR)/usr/share/wajig
 BINDIR = $(DESTDIR)/usr/bin
 MANDIR = $(DESTDIR)/usr/share/man/man1
-CMPDIR = $(DESTDIR)/etc/bash_completion.d
 
 clean:
 	rm -rf src/__pycache__
@@ -14,10 +13,8 @@
 	cp src/*.py  $(LIBDIR)/
 	cp wajig.1  $(MANDIR)/
 	install -D wajig.sh $(BINDIR)/wajig
-	cp bash-completion $(CMPDIR)/wajig
 
 uninstall:
 	rm -rf $(LIBDIR)
 	rm -f $(MANDIR)/wajig.1
 	rm -f $(BINDIR)/wajig
-	rm -f $(CMPDIR)/wajig

=== debian/changelog ===
wajig (2.17) unstable; urgency=low

  * AUTO-ALTS, UPDATE_ALTERNATIVES: update update-alternatives binary
    location (/usr/sbin -> /usr/bin);
    this has since been changed in a 2013-07-26 dpkg upload, which could
    mean no one uses these subcommands :(
  * WHICHPACKAGE: update --help description
  * CHANGELOG: avoid an exception that occurs when piping the output to
    a pager, and then quitting without reading all of that output
  * MOVE: check if apt-move is installed before trying to use it
  * Bash completion was broken in 2.16; so careless!
  * A whole bunch of code clean-up, largely assisted by Pylint

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Thu, 23 Oct 2014 23:25:38 +0200

wajig (2.16) unstable; urgency=low

  * bump Standards-Version to 3.9.6: no changes needed
  * Remove the needless debian/dirs directory; Makefile takes care of such

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Tue, 14 Oct 2014 07:17:51 +0200

wajig (2.15) unstable; urgency=low

  * WHICHPACKAGE: do not do the sneaky thing where apt-file is only used
    when there are no results from 'dpkg search'; instead, display
    installed matches in one list and uninstalled matches in another;
    also get rid of '--simulate' and '--teach' CLI options... they'd be a
    lie here, given the extra logic

  * LISTFILES: display contents of uninstalled packages if apt-file is
    installed; also, as with WHICHPACKAGE above, remove '--simulate' and
    '--teach' options, for the same reason

  * LIST-DAEMONS: use chkconfig instead of some overlong command line to
    display these sysv services

  * LARGE: avoid ValueError exception; Closes: #758129

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Mon, 13 Oct 2014 22:12:04 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Uploaders: Tshepang Lekhonkhobe <tshepang@gmail.com>
 Section: admin
 Priority: optional
-Build-Depends: debhelper (>= 9), dh-python, python3, python3-apt
+Build-Depends: debhelper (>= 9), dh-python, python3, python3-apt, bash-completion
 X-Python3-Version: >= 3.3
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Browser: https://bitbucket.org/tshepang/wajig/src
 Vcs-Hg: https://bitbucket.org/tshepang/wajig
 Homepage: http://wajig.togaware.com
@@ -34,6 +34,7 @@
           debsums,
           netselect-apt,
           dpkg-dev,
+          chkconfig,
           debtags
 Description: unified package management front-end for Debian
  A command-line wrapper around apt, apt-cache, dpkg, aptitude, and more.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --with python3 --with bash-completion

## wajig 2.18.1

=== debian/changelog ===
wajig (2.18.1) unstable; urgency=low

  * handle "possible-missing-colon-in-closes" changelog lint

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Thu, 10 Nov 2016 05:05:38 +0200

wajig (2.18) unstable; urgency=low

  * WHICHPACKAGE: handle subprocess.CalledProcessError exception; Closes: #820778
  * fix typo on tutorial; Closes: #799588
  * bump Standards-Version from 3.9.6 to 3.9.8

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Mon, 07 Nov 2016 01:46:52 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Priority: optional
 Build-Depends: debhelper (>= 9), dh-python, python3, python3-apt, bash-completion
 X-Python3-Version: >= 3.3
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://bitbucket.org/tshepang/wajig/src
 Vcs-Hg: https://bitbucket.org/tshepang/wajig
 Homepage: http://wajig.togaware.com

## wajig 2.18.1+nmu1

=== debian/changelog ===
wajig (2.18.1+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 20:14:10 +0800

## wajig 4.0.3

=== Makefile ===
########################################################################
#
# Makefile for wajig command line. 
#
# Time-stamp: <Tuesday 2021-10-26 09:04:50 AEDT Graham Williams>
#
# Copyright (c) Graham.Williams@togaware.com
#
# License: Creative Commons Attribution-ShareAlike 4.0 International.
#
########################################################################

# App version numbers
#   Major release
#   Minor update
#   Trivial update or bug fix

APP=wajig
VER=4.0.3
DATE=$(shell date +%Y-%m-%d)

TAR_GZ = dist/$(APP)-$(VER).tar.gz

BASH_COMPLETION = $(APP)/bash_completion.d/$(APP).bash

SOURCE = setup.py			\
	 docs/README.md			\
	 setup.cfg			\
	 MANIFEST.in			\
	 LICENSE			\
	 $(APP)/constants.py		\
	 $(APP)/commands.py		\
	 $(APP)/debfile-deps.py		\
	 $(APP)/debfile.py			\
	 $(APP)/perform.py			\
	 $(APP)/shell.py			\
	 $(APP)/util.py			\
	 $(APP)/__init__.py		\
	 $(APP)/bash_completion.d/wajig.bash \

# Required modules.

INC_BASE    = $(HOME)/.local/share/make
INC_CLEAN   = $(INC_BASE)/clean.mk
INC_PANDOC  = $(INC_BASE)/pandoc.mk
INC_GIT     = $(INC_BASE)/git.mk
INC_LATEX   = $(INC_BASE)/latex.mk

ifneq ("$(wildcard $(INC_CLEAN))","")
  include $(INC_CLEAN)
endif
ifneq ("$(wildcard $(INC_R))","")
  include $(INC_R)
endif
ifneq ("$(wildcard $(INC_KNITR))","")
  include $(INC_KNITR)
endif
ifneq ("$(wildcard $(INC_PANDOC))","")
  include $(INC_PANDOC)
endif
ifneq ("$(wildcard $(INC_GIT))","")
  include $(INC_GIT)
endif
ifneq ("$(wildcard $(INC_AZURE))","")
  include $(INC_AZURE)
endif
ifneq ("$(wildcard $(INC_LATEX))","")
  include $(INC_LATEX)
endif
ifneq ("$(wildcard $(INC_PDF))","")
  include $(INC_PDF)
endif
ifneq ("$(wildcard $(INC_DOCKER))","")
  include $(INC_DOCKER)
endif
ifneq ("$(wildcard $(INC_MLHUB))","")
  include $(INC_MLHUB)
endif

define HELP
$(APP):

  install	Install the current source version of $(APP) into ~/.local
  uninstall	Remove the local source installed version from ~/.local
  version	Update version from Makefile version number.

  pypi          Install onto PyPI for pip3 installation.
  deb           Build the debian package.

  snap		Build a snap.
  snapsh	Start a shell within multipass with the snap package.
  clean		Also performs snapcraft clean.

  azup          Fire up the Azure server for Debian
  azsync	Sync to deb@azure for building natively on Debian
  azbuild	Build the deb pacakge on the remote Debian server
  azget		Retrieve the built pacakge
  azdown	Shutdown the Azure server

  azlist        List VM status

endef
export HELP

help::
	@echo "$$HELP"

# modified from a version found at:
# savetheions.com/2010/01/20/packaging-python-applicationsmodules-for-debian/

DESTDIR ?= /home/$(USER)
PREFIX ?= /.local

LIBDIR = $(DESTDIR)$(PREFIX)/share/$(APP)
BINDIR = $(DESTDIR)$(PREFIX)/bin
MANDIR = $(DESTDIR)$(PREFIX)/share/man/man1

$(APP).sh: $(APP).sh.in
	sed -e 's|PREFIX|$(DESTDIR)$(PREFIX)|g' < $^ > $@

.PHONY: .version
version:
	sed -i -e "s|^    version='.*'|    version='$(VER)'|" setup.py 
	sed -i -e 's|^VERSION = ".*"|VERSION = "$(VER)"|' $(APP)/constants.py
	sed -i -e 's|^APP = ".*"|APP = "$(APP)"|' $(APP)/constants.py

# For testing a local install, install into
# ~/.local/share/wajig/wajig, with the __initi__.py in
# ~/.local/share/wajig, so it can call wajig.utils.

install: version $(APP).sh
	install -d  $(LIBDIR)/wajig $(BINDIR) $(MANDIR)
	install -D $(APP)/*.py  $(LIBDIR)/wajig/
	mv $(LIBDIR)/wajig/__init__.py $(LIBDIR)
	install -D $(APP).1  $(MANDIR)/
	install -D $(APP).sh $(BINDIR)/$(APP)
	rm $(APP).sh

uninstall:
	rm -rf $(LIBDIR)
	rm -f $(MANDIR)/$(APP).1
	rm -f $(BINDIR)/$(APP)

$(TAR_GZ): $(SOURCE)
	python3 setup.py sdist

.PHONY: tgz
tgz: $(TAR_GZ)

.PHONY: pypi
pypi: docs/README.md version tgz
	twine upload $(TAR_GZ)

# dch -v 3.0.0 will update version in changelog and allow entry.
# Might be some way to do this purely command line.

deb: version $(APP).sh
	sed -e 's|PREFIX|/usr|g' < $(APP).sh.in > $(APP).sh
	PREFIX=/usr dpkg-buildpackage -us -uc
	mv ../$(APP)_$(VER)_all.deb .
	mv ../$(APP)_$(VER)_amd64.buildinfo .
	mv ../$(APP)_$(VER)_amd64.changes .
	mv ../$(APP)_$(VER).dsc .
	mv ../$(APP)_$(VER).tar.xz .
	rm -f $(APP).sh

azup:
	az vm start --resource-group deb --name deb

azdeb:
	rsync -avzh --delete ./ deb.australiacentral.cloudapp.azure.com:$(APP)/

azbuild: azdeb
	ssh deb.australiacentral.cloudapp.azure.com 'cd $(APP); make deb'

azget: azbuild
	scp deb.australiacentral.cloudapp.azure.com:$(APP)/$(APP)_$(VER)* .

azdown:
	az vm deallocate --resource-group deb --name deb

azlist:
	az vm list --output table --show-details

# https://thecustomizewindows.com/2014/12/create-ubuntu-repository-ppa/

ppa: azget
	cd ppa
	dpkg-source -x ../$(APP)_$(VER).dsc
	cd $(APP)_$(VER)
	debuild -S -sa
	dput ppa:gjwkayon/ppa ../$(APP)_$(VER)_source.changes
.PHONY: snap
snap:
	snapcraft

snapsh:
	snapcraft prime --shell

clean::
	rm -rf $(APP)/__pycache__
	rm -f snap/*~
	snapcraft clean

realclean::
	rm -f $(APP)_$(VER)*

=== debian/changelog ===
wajig (4.0.3) unstable; urgency=low

  * Updated setup.py to make fuzzywuzzy conditional on Debian

 -- Graham Williams <Graham.Williams@togaware.com>  Sun, 26 Oct 2021 10:40:01 +1100

wajig (4.0.2) unstable; urgency=low

  * Updated debian/control to build Debian package (Dirk's fixes)
  * Depend on fuzzywuzzy on Debian, rapidfuzz if installed.
  * Model on meld: https://sources.debian.org/src/meld/3.20.4-1/debian/

 -- Graham Williams <Graham.Williams@togaware.com>  Sun, 24 Oct 2021 12:49:56 +1100

wajig (4.0.1) unstable; urgency=low

  * Debian packaging now functional again.

 -- Graham Williams <Graham.Williams@togaware.com>  Sun, 3 Oct 2021 13:52:28 +1100

wajig (3.2.25) released; urgency=low

  * Prepare for deb creation.
  * All changes recorded on github.

 -- Graham Williams <Graham.Williams@togaware.com>  Sun, 3 Oct 2021 08:51:12 +1100

wajig (3.0.0) unreleased; urgency=low

  * Kickstart wajig refresh.
  * Add REBOOT command.

 -- Graham Williams <Graham.Williams@togaware.com>  Sat, 20 Jun 2020 08:51:12 +1000

wajig (2.18.2~pre) unreleased; urgency=low

  * Use apt binary where that makes sense. (by "Reuben Thomas" <rrt@sc3d.org>)

 -- Tshepang Lekhonkhobe <tshepang@gmail.com>  Sun, 16 Sep 2018 20:56:30 +0200

=== debian/control ===
Source: wajig
Section: admin
Priority: optional
Maintainer: Graham Williams <Graham.Williams@togaware.com>
Uploaders: Dirk Eddelbuettel <edd@debian.org>
Build-Depends: dh-python,
	       python3-setuptools,
	       python3-fuzzywuzzy,
	       python3-all,
	       debhelper-compat (= 13),
	       python3-apt,
	       bash-completion
Standards-Version: 4.6.0
Vcs-Browser: https://github.com/gjwgit/wajig/wajig
Vcs-Git: https://github.com/gjwgit/wajig
Homepage: https://wajig.togaware.com

Package: wajig
Architecture: all
Depends: ${python3:Depends},
	 ${misc:Depends},
         apt,
         aptitude,
         dpkg (>= 1.16.2),
         python3-apt (>= 0.8.9),
	 python3-fuzzywuzzy
Suggests: debconf,
          reportbug,
          apt-move,
          dpkg-repack,
          alien,
          fakeroot,
          apt-file,
          locales,
          deborphan,
          vrms,
          sudo,
          apt-show-versions,
          dctrl-tools,
          debsums,
          netselect-apt,
          dpkg-dev,
          chkconfig,
          debtags
Description: unified package management front-end for Debian/Ubuntu
 A command-line wrapper around apt, apt-cache, dpkg, aptitude, and more.
 The goal is to ease system management by unifying the main functions
 of these tools from one interface.
 .
 For a short guide, run this command:
 $ wajig help

## wajig 4.0.12~mx23

=== debian/changelog ===
wajig (4.0.12~mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 16 Jan 2024 16:03:48 -0500

wajig (4.0.12) unstable; urgency=low

  * Re-sync the release on Debian with development version.
  * Depend on python3-thefuzz (Debian 12 and Ubuntu 23.04).
  * Restore wajig command completion support.
  * Fix teach functionality.

 -- Graham Williams <Graham.Williams@togaware.com>  Sat, 8 Jul 2023 10:37:58 +1000

wajig (4.0.7) UNRELEASED; urgency=medium

  * The fuzzywuzzy Python library has been renamed, it is now thefuzz.

 -- Edward Betts <edward@4angle.com>  Sun, 06 Nov 2022 15:31:19 +0000

wajig (4.0.4) UNRELEASED; urgency=medium

  * Remove constraints unnecessary since buster (oldstable):
    + wajig: Drop versioned constraint on dpkg and python3-apt in Depends.

 -- Debian Janitor <janitor@jelmer.uk>  Fri, 09 Sep 2022 08:41:02 -0000

## wajig 4.0.12

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Makefile for wajig command line. 
 #
-# Time-stamp: <Tuesday 2021-10-26 09:04:50 AEDT Graham Williams>
+# Time-stamp: <Saturday 2023-07-08 07:37:32 +1000 Graham Williams>
 #
 # Copyright (c) Graham.Williams@togaware.com
 #
@@ -16,7 +16,7 @@
 #   Trivial update or bug fix
 
 APP=wajig
-VER=4.0.3
+VER=4.0.12
 DATE=$(shell date +%Y-%m-%d)
 
 TAR_GZ = dist/$(APP)-$(VER).tar.gz
@@ -40,7 +40,7 @@
 
 # Required modules.
 
-INC_BASE    = $(HOME)/.local/share/make
+INC_BASE    = support
 INC_CLEAN   = $(INC_BASE)/clean.mk
 INC_PANDOC  = $(INC_BASE)/pandoc.mk
 INC_GIT     = $(INC_BASE)/git.mk
@@ -80,7 +80,7 @@
 define HELP
 $(APP):
 
-  install	Install the current source version of $(APP) into ~/.local
+  install	NOT REQUIRED - already installed as 'pip install -e .'
   uninstall	Remove the local source installed version from ~/.local
   version	Update version from Makefile version number.
 
@@ -91,13 +91,14 @@
   snapsh	Start a shell within multipass with the snap package.
   clean		Also performs snapcraft clean.
 
+  access	Buld and copy deb to access.togaware.com
+    azsync	Sync to deb@azure for building natively on Debian
+    azbuild	Build the deb pacakge on the remote Debian server
+    azget	Retrieve the built pacakge
+
+  azstatus      VM status
   azup          Fire up the Azure server for Debian
-  azsync	Sync to deb@azure for building natively on Debian
-  azbuild	Build the deb pacakge on the remote Debian server
-  azget		Retrieve the built pacakge
-  azdown	Shutdown the Azure server
-
-  azlist        List VM status
+  azdown	Shut down the Azure server.
 
 endef
 export HELP
@@ -128,13 +129,10 @@
 # ~/.local/share/wajig/wajig, with the __initi__.py in
 # ~/.local/share/wajig, so it can call wajig.utils.
 
+# 20230202 Use pip -e for local install now.
+
 install: version $(APP).sh
-	install -d  $(LIBDIR)/wajig $(BINDIR) $(MANDIR)
-	install -D $(APP)/*.py  $(LIBDIR)/wajig/
-	mv $(LIBDIR)/wajig/__init__.py $(LIBDIR)
-	install -D $(APP).1  $(MANDIR)/
-	install -D $(APP).sh $(BINDIR)/$(APP)
-	rm $(APP).sh
+	@echo "NOT REQUIRED. USE 'pip install -e .'"
 
 uninstall:
 	rm -rf $(LIBDIR)
@@ -164,6 +162,8 @@
 	mv ../$(APP)_$(VER).tar.xz .
 	rm -f $(APP).sh
 
+# 20230708 gjw az support has been removed.
+
 azup:
 	az vm start --resource-group deb --name deb
 
@@ -179,8 +179,11 @@
 azdown:
 	az vm deallocate --resource-group deb --name deb
 
-azlist:
-	az vm list --output table --show-details
+azstatus:
+	az vm list --output table --show-details | egrep '(Name|----|deb)'
+
+access: azget
+	rsync --perms --chmod=u+rw,g+r,o+r $(APP)_$(VER)_all.deb togaware.com:apps/access/
 
 # https://thecustomizewindows.com/2014/12/create-ubuntu-repository-ppa/
 
@@ -204,3 +207,6 @@
 
 realclean::
 	rm -f $(APP)_$(VER)*
+
+README.pdf: README.rst
+	pandoc -V urlcolor=cyan -V geometry=a4paper -V lang=en-AU -V babel-lang=british --standalone --listings README.rst -o README.pdf

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Dirk Eddelbuettel <edd@debian.org>
 Build-Depends: dh-python,
 	       python3-setuptools,
-	       python3-fuzzywuzzy,
+	       python3-thefuzz,
 	       python3-all,
 	       debhelper-compat (= 13),
 	       python3-apt,
@@ -21,9 +21,8 @@
 	 ${misc:Depends},
          apt,
          aptitude,
-         dpkg (>= 1.16.2),
-         python3-apt (>= 0.8.9),
-	 python3-fuzzywuzzy
+         python3-apt,
+	 python3-thefuzz,
 Suggests: debconf,
           reportbug,
           apt-move,

## wajig 4.1.2

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Makefile for wajig command line. 
 #
-# Time-stamp: <Saturday 2023-07-08 07:37:32 +1000 Graham Williams>
+# Time-stamp: <Monday 2024-03-04 13:36:39 +1100 Graham Williams>
 #
 # Copyright (c) Graham.Williams@togaware.com
 #
@@ -16,7 +16,7 @@
 #   Trivial update or bug fix
 
 APP=wajig
-VER=4.0.12
+VER=4.1.2
 DATE=$(shell date +%Y-%m-%d)
 
 TAR_GZ = dist/$(APP)-$(VER).tar.gz
@@ -148,6 +148,7 @@
 .PHONY: pypi
 pypi: docs/README.md version tgz
 	twine upload $(TAR_GZ)
+	git tag v${VER} && git push --tags
 
 # dch -v 3.0.0 will update version in changelog and allow entry.
 # Might be some way to do this purely command line.

=== debian/changelog ===
wajig (4.1.2) unstable; urgency=high

  * Remove dependency of thefuzz/rapidfuzz due to imminent removal
    of python-levenshtein 8 Mar 2024. This may be a temporary
    issue. In the meantime, no fuzzy command functionality.

 -- Graham Williams <Graham.Williams@togaware.com>  Tue, 3 Mar 2024 06:01:15 +1100

wajig (4.1.1) UNRELEASED; urgency=low

  * Implement DISABLE and ENABLE for user accounts.
  * Implement ADDGROUP, RMGROUP, LISTGROUPS for user group management.
  * Support tags on each new pypi release.

 -- Graham Williams <Graham.Williams@togaware.com>  Sun, 9 Jul 2023 16:01:00 +1000

## wajig 4.1.3

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 # Makefile for wajig command line. 
 #
-# Time-stamp: <Monday 2024-03-04 13:36:39 +1100 Graham Williams>
+# Time-stamp: <Thursday 2024-12-05 08:38:27 +1100 Graham Williams>
 #
 # Copyright (c) Graham.Williams@togaware.com
 #
@@ -16,7 +16,7 @@
 #   Trivial update or bug fix
 
 APP=wajig
-VER=4.1.2
+VER=4.1.3
 DATE=$(shell date +%Y-%m-%d)
 
 TAR_GZ = dist/$(APP)-$(VER).tar.gz

=== debian/changelog ===
wajig (4.1.3) unstable; urgency=low

  * New SAFEUPGRADE command to install any packages being held back due to
    their being phased released.

  * Update UPGRADE to always upgrade without asking as per #22.

 -- Graham Williams <Graham.Williams@togaware.com>  Thu, 5 Dec 2024 08:32:21 +1100

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,11 @@
 Uploaders: Dirk Eddelbuettel <edd@debian.org>
 Build-Depends: dh-python,
 	       python3-setuptools,
-	       python3-thefuzz,
 	       python3-all,
 	       debhelper-compat (= 13),
 	       python3-apt,
 	       bash-completion
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://github.com/gjwgit/wajig/wajig
 Vcs-Git: https://github.com/gjwgit/wajig
 Homepage: https://wajig.togaware.com
@@ -22,7 +21,6 @@
          apt,
          aptitude,
          python3-apt,
-	 python3-thefuzz,
 Suggests: debconf,
           reportbug,
           apt-move,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export PYBUILD_NAME=wajig

%:
	dh $@ --buildsystem=pybuild --with python3 --with bash-completion

## wajig 4.1.3build1

=== debian/changelog ===
wajig (4.1.3build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 29 Jan 2026 22:04:51 +0100
